import { Ref } from 'react';
import { StyleProp, TextStyle, LayoutChangeEvent } from 'react-native';

export interface Highlight {
  start: number;
  end: number;
  id: string;
}

export type onWordPressIOSNativeEvent = {
  nativeEvent: { clickedRangeStart: number; clickedRangeEnd: number };
};

export interface Selection {
  start: number;
  end: number;
  rect: {
    x: number;
    y: number;
    width: number;
    height: number;
  };
}

export interface HighlightRectsCalculatedNativeEvent {
  nativeEvent: {
    rects: Array<{
      id: string;
      rect: {
        x: number;
        y: number;
        width: number;
        height: number;
      };
    }>;
  };
}

export interface SelectionChangeNativeEvent {
  nativeEvent: { selection: Selection };
}

export type HighlightableTextRef = {};

export type RNSelectableTextProps = {
  children: any;
  ref?: Ref<HighlightableTextRef>;
  style: StyleProp<TextStyle>;
  selectable?: boolean;
  highlights?: Highlight[];
  onWordPress: (event: onWordPressIOSNativeEvent) => void;
  onTextSelectionChange: (event: SelectionChangeNativeEvent) => void;
  onHighlightRectsCalculated?: (
    event: HighlightRectsCalculatedNativeEvent
  ) => void;
  onLayout?: (event: LayoutChangeEvent) => void;
};

export type RNSelectableTextRectHelper = {
  getRectForSubstring: (
    reactTag: number,
    start: number,
    end: number
  ) => Promise<{
    rects: Array<{
      x: number;
      y: number;
      width: number;
      height: number;
    }>;
  }>;
};
